<?xml version="1.0" encoding="UTF-8"?>
<project xmlns="http://maven.apache.org/POM/4.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
    <modelVersion>4.0.0</modelVersion>

    <groupId>net.ihe.gazelle</groupId>
    <artifactId>sso-client-v7</artifactId>
    <version>5.0.1-SNAPSHOT</version>
    <packaging>pom</packaging>

    <modules>
        <module>sso-api-v7</module>
        <module>cas-client-v7</module>
        <module>cas-client-ui-v7</module>
        <module>gum-client</module>
        <module>sso-commons-v7</module>
        <module>m2m-v7</module>
    </modules>

    <scm>
        <connection>scm:git:${git.project.url}</connection>
        <developerConnection>scm:git:${git.project.url}</developerConnection>
        <url>https://gitlab.inria.fr/${git.project.path}</url>
        <tag>3.0.0</tag>
    </scm>

    <properties>
        <maven.compiler.source>1.7</maven.compiler.source>
        <maven.compiler.target>1.7</maven.compiler.target>
        <project.build.sourceEncoding>UTF-8</project.build.sourceEncoding>

        <git.user.name>git</git.user.name>
        <git.user.token>git</git.user.token>
        <git.project.path>gazelle/public/framework/sso-client-v7</git.project.path>
        <git.project.url>https://${git.user.name}:${git.user.token}@gitlab.inria.fr/${git.project.path}
        </git.project.url>

        <maven.release.plugin.version>2.5.3</maven.release.plugin.version>
        <maven.surefire.plugin.version>3.0.0</maven.surefire.plugin.version>
        <nexus.staging.maven.plugin.version>1.6.8</nexus.staging.maven.plugin.version>
        <sonar.maven.plugin>3.5.0.1254</sonar.maven.plugin>
        <jacoco.version>0.8.1</jacoco.version>
        <gazelle.plugins.version>1.60</gazelle.plugins.version>
        <crowdin.plugin.version>1.5</crowdin.plugin.version>
        <junit.version>4.13.2</junit.version>
        <httpclient.version>4.5.14</httpclient.version>
        <httpcore.version>4.4.16</httpcore.version>
        <test.mock.port>10101</test.mock.port>
        <io.jsonwebtoken.version>0.12.5</io.jsonwebtoken.version>
        <wiremock-standalone.version>2.27.2</wiremock-standalone.version>
    </properties>

    <build>
        <plugins>
            <plugin>
                <groupId>org.jacoco</groupId>
                <artifactId>jacoco-maven-plugin</artifactId>
                <version>${jacoco.version}</version>
                <executions>
                    <execution>
                        <id>prepare-jacoco-agent</id>
                        <goals>
                            <goal>prepare-agent</goal>
                        </goals>
                    </execution>
                    <execution>
                        <id>jacoco-report</id>
                        <phase>test</phase>
                        <goals>
                            <goal>report</goal>
                        </goals>
                    </execution>
                </executions>
            </plugin>
            <plugin>
                <artifactId>maven-surefire-plugin</artifactId>
                <version>${maven.surefire.plugin.version}</version>
                <dependencies>
                    <dependency>
                        <groupId>org.apache.maven.surefire</groupId>
                        <artifactId>surefire-junit47</artifactId>
                        <version>${maven.surefire.plugin.version}</version>
                    </dependency>
                </dependencies>
                <configuration>
                    <!-- Configure some variable environments for unit tests-->
                    <systemPropertyVariables>
                        <testMockPort>${test.mock.port}</testMockPort>
                    </systemPropertyVariables>
                    <argLine>${argLine} -DtestMockPort=${test.mock.port}</argLine>
                </configuration>
            </plugin>
        </plugins>
        <pluginManagement>
            <plugins>
                <plugin>
                    <groupId>org.codehaus.mojo</groupId>
                    <artifactId>gazelle-plugins</artifactId>
                    <version>${gazelle.plugins.version}</version>
                </plugin>
                <plugin>
                    <groupId>com.googlecode.crowdin-maven</groupId>
                    <artifactId>crowdin-plugin</artifactId>
                    <configuration>
                        <crowdinServerId>crowdin-gazelle</crowdinServerId>
                    </configuration>
                </plugin>
            </plugins>
        </pluginManagement>
    </build>
    <profiles>
        <profile>
            <id>sonar</id>
            <properties>
                <!-- Exclude AuthenticationFilter: this class is duplicated from Apereo CAS Client library for overriding one single line.
                Even if we should not duplicate a class to alter its behavior, code smell/issues on duplicated parts is not our
                responsability to fix. -->
                <sonar.exclusions>**/net/ihe/gazelle/cas/client/authentication/AuthenticationFilter.java</sonar.exclusions>
            </properties>
        </profile>
        <profile>
            <id>release</id>
            <build>
                <plugins>
                    <plugin>
                        <groupId>org.sonatype.plugins</groupId>
                        <artifactId>nexus-staging-maven-plugin</artifactId>
                        <version>${nexus.staging.maven.plugin.version}</version>
                        <executions>
                            <execution>
                                <id>default-deploy</id>
                                <phase>deploy</phase>
                                <goals>
                                    <goal>deploy</goal>
                                </goals>
                            </execution>
                        </executions>
                        <configuration>
                            <serverId>nexus-releases</serverId>
                            <nexusUrl>https://gazelle.ihe.net/nexus</nexusUrl>
                            <skipStaging>true</skipStaging>
                        </configuration>
                    </plugin>
                </plugins>
            </build>
        </profile>
    </profiles>

    <dependencyManagement>
        <dependencies>
            <dependency>
                <groupId>net.ihe.gazelle</groupId>
                <artifactId>sso-api-v7</artifactId>
                <version>5.0.1-SNAPSHOT</version>
            </dependency>
            <dependency>
                <groupId>net.ihe.gazelle</groupId>
                <artifactId>sso-commons-v7</artifactId>
                <version>5.0.1-SNAPSHOT</version>
            </dependency>
            <dependency>
                <groupId>net.ihe.gazelle</groupId>
                <artifactId>cas-client-v7</artifactId>
                <version>5.0.1-SNAPSHOT</version>
            </dependency>
            <dependency>
                <groupId>net.ihe.gazelle</groupId>
                <artifactId>gum-client</artifactId>
                <version>5.0.1-SNAPSHOT</version>
            </dependency>
            <dependency>
                <groupId>net.ihe.gazelle</groupId>
                <artifactId>cas-client-ui-v7</artifactId>
                <version>5.0.1-SNAPSHOT</version>
                <type>war</type>
            </dependency>
            <dependency>
                <groupId>net.ihe.gazelle</groupId>
                <artifactId>m2m-v7</artifactId>
                <version>5.0.1-SNAPSHOT</version>
            </dependency>

            <dependency>
                <groupId>net.ihe.gazelle.maven</groupId>
                <artifactId>gazelle-seam</artifactId>
                <version>2.0.11</version>
                <type>pom</type>
                <scope>import</scope>
            </dependency>
            <dependency>
                <groupId>net.ihe.gazelle</groupId>
                <artifactId>gazelle-preferences</artifactId>
                <version>1.1.0</version>
                <type>ejb</type>
                <scope>provided</scope>
                <exclusions>
                    <exclusion>
                        <groupId>org.mapdb</groupId>
                        <artifactId>mapdb</artifactId>
                    </exclusion>
                    <exclusion>
                        <groupId>net.ihe.gazelle.hql</groupId>
                        <artifactId>gazelle-hql</artifactId>
                    </exclusion>
                </exclusions>
            </dependency>
            <dependency>
                <groupId>net.ihe.gazelle</groupId>
                <artifactId>metadata-v7</artifactId>
                <version>1.0.0</version>
                <type>ejb</type>
            </dependency>
            <dependency>
                <groupId>net.ihe.gazelle.hql</groupId>
                <artifactId>gazelle-hql</artifactId>
                <version>2.1.4</version>
                <scope>provided</scope>
            </dependency>
            <dependency>
                <groupId>org.apache.httpcomponents</groupId>
                <artifactId>httpclient</artifactId>
                <version>${httpclient.version}</version>
            </dependency>
            <dependency>
                <groupId>org.apache.httpcomponents</groupId>
                <artifactId>httpcore</artifactId>
                <version>${httpcore.version}</version>
            </dependency>
            <dependency>
                <groupId>com.fasterxml.jackson.core</groupId>
                <artifactId>jackson-databind</artifactId>
                <version>2.12.6</version>
            </dependency>
        </dependencies>
    </dependencyManagement>

    <repositories>
        <repository>
            <id>ihe-services</id>
            <name>IHE Services Public Maven Repository Group</name>
            <url>https://gazelle.ihe.net/nexus/content/groups/public/</url>
            <layout>default</layout>
            <releases>
                <enabled>true</enabled>
                <updatePolicy>never</updatePolicy>
            </releases>
            <snapshots>
                <enabled>true</enabled>
            </snapshots>
        </repository>
    </repositories>

    <pluginRepositories>
        <pluginRepository>
            <id>ihe-services-plugins</id>
            <name>IHE Services Public Maven Repository Group</name>
            <url>https://gazelle.ihe.net/nexus/content/groups/public/</url>
            <layout>default</layout>
            <releases>
                <enabled>true</enabled>
                <updatePolicy>never</updatePolicy>
            </releases>
            <snapshots>
                <enabled>true</enabled>
            </snapshots>
        </pluginRepository>
    </pluginRepositories>

    <distributionManagement>
        <repository>
            <id>nexus-releases</id>
            <url>https://gazelle.ihe.net/nexus/content/repositories/releases</url>
        </repository>
        <snapshotRepository>
            <id>nexus-snapshots</id>
            <url>https://gazelle.ihe.net/nexus/content/repositories/snapshots/</url>
        </snapshotRepository>
    </distributionManagement>

</project>
